=== debian/changelog ===
wasmedge (0.16.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Remove examples/capi/mandelbrot patch, fixed upstream.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 06 Jan 2026 11:38:30 +0200
