=== debian/watch ===
Version: 5

Template: Github
Owner: WasmEdge
Project: WasmEdge
Repacksuffix: +dfsg
Dversion-mangle: auto
Uversion-Mangle: s/-(alpha|beta|rc)\.?/~$1/
